#include "Vista.h"
	SUBROUTINE EXPAND

C       Expands and image into double size.

C       This routine expands an image into double size, but with
C	leaving 3 of the new pixels in each 2x2 new patch filled with
C	zeros.  This is done for combining dithered HST images.
C
C       EXPAND destination source [BOX=b]
C
C       BOX is used to select a section of an image.
C
C       Author: Tod R. Lauer    1/28/98


#ifdef VMS
	INCLUDE 'VINCLUDE:VISTALINK.INC'       ! Communication with VISTA
	INCLUDE 'VINCLUDE:IMAGELINK.INC'       ! Image parameters
#else
	INCLUDE 'vistadisk/source/include/vistalink.inc'
	INCLUDE 'vistadisk/source/include/imagelink.inc'
#endif
	REAL*8 TMP
	CHARACTER PARM*8, CCHEAD*80
	INTEGER SR, SC, ER, EC, BN
	LOGICAL KEYCHECK, HAVEBOX, DUMMY

C       List allowed keywords.

	CALL KEYINIT
	CALL KEYDEF('BOX=')

C       If the user gives any keywords we do not understand, we exit.

	IF (COM .NE. 'FIND' .AND. COM .NE. 'SUB*') THEN
	  IF (.NOT. KEYCHECK()) THEN
		XERR = .TRUE.
		RETURN
	  END IF
	END IF

C       Initializations.

	HAVEBOX         = .FALSE.

C       Get command arguments.

	BN = 0
	DO 8701 I=1, NWORD
		IF (WORD(I)(1:4) .EQ. 'BOX=') THEN
			CALL ASSIGN(WORD(I),F,PARM)
			IF (XERR) RETURN
			BN = NINT(F)
			HAVEBOX = .TRUE.
		END IF
8701    CONTINUE

C       Get the position of the original image on the command line.

	NP = 2

C       Fetch the image to be copied or windowed.

	CALL GETIMAGE(LOCIM,SR,ER,SC,EC,NP)
	IF (XERR) RETURN

C       Get the number of the old image.

	IMCOP = JM

C       Note the size of the old image.

	NROW = ER - SR + 1
	NCOL = EC - SC + 1

C       Make a copy of the current image header.

	TEMPHEAD = ' '
	CALL CCVSTRCPY(TEMPHEAD,HEADBUF(1,IMCOP))

C       Set the image parameters to be the size of the box.

	IF (BN .GT. 0) THEN

C               Get the box parameters.

		CALL GETBOX(BN,ICOORD(1,IMCOP),SR,ER,SC,EC)
		IF (XERR) RETURN

C               Set the number of rows and columns in the new header.

		NEWROW = 2*(ER - SR + 1)
		NEWCOL = 2*(EC - SC + 1)

		CALL INHEADSET('NAXIS1',NEWCOL,TEMPHEAD)
		CALL INHEADSET('NAXIS2',NEWROW,TEMPHEAD)

C--          Reset the reference CRVAL (because of boxing) and CNPIX if there
		JDELT = SC - ICOORD(IXSC,IMCOP)
		IDELT = SR - ICOORD(IYSR,IMCOP)
		TMP = CRVAL1(IMCOP) + CDELT1(IMCOP)*JDELT
		CALL FHEADSET('CRVAL1',TMP,TEMPHEAD)
		TMP = CRVAL2(IMCOP) + CDELT2(IMCOP)*IDELT
		CALL FHEADSET('CRVAL2',TMP,TEMPHEAD)
		CCHEAD = ' '
		CALL CHEAD('CNPIX1',TEMPHEAD,CCHEAD)
                IF (CCHEAD .NE. ' ')
     &               CALL INHEADSET('CNPIX1',SC,TEMPHEAD)
		CCHEAD = ' '
		CALL CHEAD('CNPIX2',TEMPHEAD,CCHEAD)
                IF (CCHEAD .NE. ' ')
     &               CALL INHEADSET('CNPIX2',SR,TEMPHEAD)

	ELSE
		JDELT = 0
		IDELT = 0
		NEWROW = 2*NROW
		NEWCOL = 2*NCOL
		CALL INHEADSET('NAXIS1',NEWCOL,TEMPHEAD)
		CALL INHEADSET('NAXIS2',NEWROW,TEMPHEAD)
	END IF

C       Make the new image.

	DUMMY = .TRUE.
	CALL CREATEIM(LOCNEW,SR,ER,SC,EC,1,TEMPHEAD,DUMMY)
	IF (XERR) RETURN

C       The actual tranfer of the array is done by the COPIO routine.
	CALL CC1EXPIO(LOCNEW,NEWROW,NEWCOL,
     .          LOCIM,NROW,NCOL,IDELT,JDELT)

	RETURN
	END
